#ifndef ccnb_h
#define ccnb_h

#include "defo.h"

#include "bodies.h"
#include "krawczyk-newton.h"

#include <future>
#include <thread>

using namespace std;
using namespace capd;

/* ============ *
 *   Globals    *
 * ============ */

// Defining enum phase
enum Phase
{
    searchmode, // when program is in SEARCHING PHASE
    testing     // when program is in TESTING PHASE, even if it currently searches for zeros
};
extern Phase phase;

extern ofstream mathFile;
extern ofstream mathListFile;
extern ofstream mathCyclesFile;

extern mutex updateCounter_mutex;
extern mutex krawczykSection_mutex;
extern mutex write_mutex;
extern mutex pathUpdate_mutex;

extern std::atomic<int> cnt;

extern atomic<long long> boxCount; // number of checked boxes
extern atomic<long long> clusterImprovementCounter;
extern atomic<long long> interQuadCounter;
extern atomic<long long> aprioriCounter;
extern atomic<long long> clusterCounter;
extern atomic<long long> distanceCounter;
extern atomic<long long> checkZeroCounter;
extern atomic<long long> KrawczykFailedCounter;
extern atomic<long long> KrawczykZeroCounter;
extern atomic<long long> KrawczykNoZeroCounter;
extern atomic<long long> methodFailedCounter;
//extern atomic<long long> methodZeroes;
extern atomic<long long> UEqICounter;
extern atomic<long long> isoBoxesCount;

extern int MAX_ITER_NEWTON;
extern int MAX_ASYNC_DEPTH;

extern MyDouble bias;
extern MyDouble eps;
extern ZeroSearchType methodUsed;
extern bool equalMasses;
extern bool orderIncreasing;
extern bool fixedOrderOfBodies;

#endif
